# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, random, popuplib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func = es.import_addon('sam/functions')
core = es.import_addon('sam/core')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #

CACHE     = {'t':False}
immFILTER = {}
dbname    = 'sam_admins.db'
db        = func.getDB(dbname)
for x in ('admins','groups'):
	if not db.has_key(x): db[x] = {}

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x ####### ADMIN PERMISSIONS ###### xx #
access = ['Admins Manager','Addons Monitor','Kick','Unban','Manage Teams','Mute','Map Change','Admins Chat','Server RCON','Slay',
		  'Fun Controls','Server Commands','Server Restart','Admin Sounds','Prop Spawning']
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# UPDATE GROUPS PERMISSIONS
	for group in db['groups']:
		for x in access:
			if not x in db['groups'][group]: db['groups'][group][x] = False

	# CMDS
	func.ServerCMD('sam_admins_reset', resetCMD)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# FILTERS
	for x in (create_admin_FILTER,create_group_FILTER):
		try: es.addons.unregisterSayFilter(x)
		except: pass

	# CMDS
	func.unServerCMD('sam_admins_reset')

	# SAVE DATABASE
	func.saveDB(dbname, db)

	# POPUPS
	func.popupDelete('ADMINS_MAIN')
	func.popupDelete('ADMINS_LIST')
	func.popupDelete('ADMINS_EDIT')
	func.popupDelete('ADMINS_QUICK_ADDGROUP')
	func.popupDelete('ADMINS_IMMUNITY_EDIT')
	func.popupDelete('GROUPS_LIST')
	func.popupDelete('GROUPS_EDIT')
	func.popupDelete('GROUPS_QUICK_ADD')
	func.popupDelete('GROUPS_COLOR')
	func.popupDelete('GROUPS_IMMUNITY_EDIT')
	func.popupDelete('CREATE_ADMIN')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID,SEND=True):
	if can(ID, 'Admins Manager') or not SEND:
		if not popuplib.exists('ADMINS_MAIN'):
			popup = func.simplemenu('ADMINS_MAIN','HOME')
			popup.addline(func.header(func.langCommon('TITLE_ADMINS')))
			popup.addline(func.line)
			popup.addline('->1. %s' % func.langAdmins('ADD_ADMIN_OPTION'))
			popup.addline('->2. %s' % func.langAdmins('REMOVE_ADMIN_OPTION'))
			popup.addline('->3. %s' % func.langAdmins('EDIT_ADMIN_OPTION'))
			popup.addline('%s\n :: %s' % (func.line,func.langCommon('GROUPS').upper()))
			popup.addline(func.line)
			popup.addline('->4. %s' % func.langAdmins('ADD_GROUP_OPTION'))
			popup.addline('->5. %s' % func.langAdmins('REMOVE_GROUP_OPTION'))
			popup.addline('->6. %s' % func.langAdmins('EDIT_GROUP_OPTION'))
			popup.addline(func.line)
			popup.addline('->0. %s' % func.langCommon('CANCEL'))
			popup.menuselect = admins_main_SELECT
		if SEND:
			popup = popuplib.find('ADMINS_MAIN')
			popup.send(ID)
	else: core.home(ID)

# ------------------------------------------------------------------------------- #
def admins_main_SELECT(ID, CHOICE, POPUP):
	a = {1:'ADD',2:'REMOVE',3:'EDIT',5:'REMOVE_GROUP',6:'EDIT_GROUP'}
	if CHOICE in (1,2,3):
		if   CHOICE == 1: popup = func.easymenu(('ADMINS_LIST', add),'ADMINS_MAIN')
		elif CHOICE == 2: popup = func.easymenu(('ADMINS_LIST', remove),'ADMINS_MAIN')
		elif CHOICE == 3: popup = func.easymenu(('ADMINS_LIST', edit),'ADMINS_MAIN')
		popup.settitle(func.header(func.langAdmins('%s_ADMIN_OPTION' % a[CHOICE])))
		humans = playerlib.getPlayerList('#human')
		if CHOICE == 1:
			l = [ply for ply in humans if not isAdmin(ply)]
			if len(l):
				for x in l: popup.addoption(x, x.name)
				popup.send(ID)
			else:
				func.hudhint(ID, func.langCommon('NO_PLAYERS_TOLIST'), func.adminstag)
				page(ID)
		elif CHOICE in (2,3):
			for x in humans:
				if isAdmin(x.steamid): update(x)
			if db['admins'][es.getplayersteamid(ID)]['Super Admin']: l = [x for x in db['admins']]
			else: l = [x for x in db['admins'] if not db['admins'][x]['Super Admin']]
			if len(l):
				for x in l:
					if db['admins'][x]['Super Admin']: popup.addoption(x, '%s (Super Admin)'%db['admins'][x]['name'])
					elif db['admins'][x]['group']: popup.addoption(x, '%s (%s)' % (db['admins'][x]['name'],db['admins'][x]['group'].capitalize()))
					else: popup.addoption(x, db['admins'][x]['name'])
			else: func.hudhint(ID, func.langAdmins('NO_ADMINS_TOLIST'), func.adminstag)
			popup.send(ID)
	elif CHOICE in (4,5,6):
		if CHOICE == 4:
			CACHE[ID] = 'GROUP_FILTER'
			func.cloud['filters'].append(ID)
			es.addons.registerSayFilter(create_group_FILTER)
			func.hudhint(ID, func.langAdmins('TYPE_GROUP_NAME'), func.adminstag)
		elif CHOICE in (5,6):
			if len(list(db['groups'])):
				if   CHOICE == 5: popup = func.easymenu(('GROUPS_LIST', remove_group), 'ADMINS_MAIN')
				elif CHOICE == 6: popup = func.easymenu(('GROUPS_LIST', edit_group), 'ADMINS_MAIN')
				popup.settitle(func.header(func.langAdmins('%s_OPTION' % a[CHOICE])))
				for x in db['groups']: popup.addoption(x, db['groups'][x]['name'])
				popup.send(ID)
			else:
				func.hudhint(ID, func.langAdmins('NO_GROUPS_TOLIST'), func.adminstag)
				page(ID)

# =============================================================================== #
# === <<<> ADMINS MAIN FUNCTIONS <>>> =========================================== #
# =============================================================================== #
def add(ID, target, POPUP='ADMINS_LIST', KEY=False, S=False):
	d = db['admins']
	t = {'i':{True:100,False:0},'b':{True:2,False:0}}
	if not target.steamid in d:
		d[target.steamid] = {'name':target.name,'group':False,'imm':t['i'][KEY],'Ban Level':t['b'][KEY]}
		d[target.steamid]['Super Admin'] = S
		for x in access: d[target.steamid][x] = KEY
		db.update(d)
		func.hudhint(ID, func.langAdmins('ADMIN_ADDED', {'target':target.name}), func.adminstag)
		edit(ID, target.steamid, POPUP)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def remove(ID, TARGET, POPUP):
	superadmins = [x for x in db['admins'] if db['admins'][x]['Super Admin']]
	if TARGET in superadmins:
		if len(superadmins) >= 2:
			func.hudhint(ID, func.langAdmins('ADMIN_REMOVED', {'target':db['admins'][TARGET]['name']}), func.adminstag)
			del db['admins'][TARGET]
		else: func.hudhint(ID, func.langAdmins('NEED_SUPER_ADMIN'), func.adminstag)
	else:
		func.hudhint(ID, func.langAdmins('ADMIN_REMOVED', {'target':db['admins'][TARGET]['name']}), func.adminstag)
		del db['admins'][TARGET]
	page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def edit(ID, TARGET, POPUP='ADMINS_LIST', PAGE=False):
	CACHE[ID] = TARGET
	logic = {True:func.langCommon('YES'),False:func.langCommon('NO')}
	admin = db['admins'][TARGET]
	popup = func.easymenu(('ADMINS_EDIT', admins_edit_SELECT),POPUP,False)
	popup.c_beginsep = '%s\n%s: %s\nID: %s\n%s' % (func.line,func.langCommon('NAME').upper(),admin['name'],TARGET,func.line)
	popup.settitle(func.header(func.langAdmins('EDIT_ADMIN_OPTION')))
	popup.addoption(1, func.langAdmins('TOGGLE_ACCESS'))
	if db['admins'][es.getplayersteamid(ID)]['Super Admin']: popup.addoption(2, 'Super Admin: %s' % logic[admin['Super Admin']])
	if admin['group']: groupline = '%s: %s' % (func.langCommon('GROUP'),db['groups'][admin['group']]['name'])
	else: groupline = '%s: None' % (func.langCommon('GROUP'))
	popup.addoption(3, groupline)
	popup.addoption(4, '%s: %s' % (func.langAdmins('IMMUNITY_LEVEL'),admin['imm']))
	popup.addoption(5, 'Ban Level: %s' % admin['Ban Level'])
	for x in access: popup.addoption(x, '%s: %s' % (x,logic[admin[x]]))
	if not PAGE: popup.send(ID)
	else: popup.sendPage(ID, PAGE)

# ------------------------------------------------------------------------------- #
def admins_edit_SELECT(ID, KEY, POPUP):
	ADMIN = db['admins'][CACHE[ID]]
	if   KEY == 1: toggle(CACHE[ID], 'admins')
	elif KEY == 2:
		if ADMIN['Super Admin']:
			if len([x for x in db['admins'] if db['admins'][x]['Super Admin']]) >= 2: ADMIN['Super Admin'] = False
			else: func.hudhint(ID, func.langAdmins('NEED_SUPER_ADMIN'), func.adminstag)
		else: ADMIN['Super Admin'] = True
	elif KEY == 3:
		if len(list(db['groups'])):
			popup = func.easymenu(('ADMINS_QUICK_ADDGROUP', choose_group_SELECT),'ADMINS_EDIT',False)
			popup.settitle(func.header(func.langAdmins('EDIT_ADMIN_OPTION')))
			popup.addoption('rem', func.langAdmins('REMOVE_GROUP'))
			for x in db['groups']: popup.addoption(x, db['groups'][x]['name'])
			popup.send(ID)
		else:
			func.hudhint(ID, func.langAdmins('NO_GROUPS'), func.adminstag)
			edit(ID, CACHE[ID], 'ADMINS_LIST')
	elif KEY == 4:
		popup = func.easymenu(('ADMINS_IMMUNITY_EDIT', immunity_edit_SELECT),'ADMINS_EDIT',False)
		popup.settitle(func.header(func.langAdmins('EDIT_ADMIN_OPTION')))
		num = 0
		while num <= 100:
			popup.addoption(num, num)
			num += 10
		popup.send(ID)
	elif KEY == 5:
		logic = {0:1,1:2,2:0}
		ADMIN['Ban Level'] = logic[ADMIN['Ban Level']]
	else:
		if ADMIN[KEY]: ADMIN[KEY] = False
		else: ADMIN[KEY] = True
	db['admins'][CACHE[ID]].update(ADMIN)
	if not KEY in (3,4):
		if KEY in access: KEY = func.sendPage(access.index(KEY)+6)
		else: KEY = 1
		edit(ID, CACHE[ID], 'ADMINS_LIST', KEY)

# ------------------------------------------------------------------------------- #
def choose_group_SELECT(ID, GROUP, POPUP):
	if GROUP == 'rem': GROUP = False
	db['admins'][CACHE[ID]]['group'] = GROUP
	edit(ID, CACHE[ID], 'ADMINS_LIST')

# ------------------------------------------------------------------------------- #
def immunity_edit_SELECT(ID, LEVEL, POPUP):
	db['admins'][CACHE[ID]]['imm'] = LEVEL
	func.hudhint(ID, func.langAdmins('IMMUNITY_EDITED',{'admin':db['admins'][CACHE[ID]]['name'],'imm':LEVEL}), func.adminstag)
	edit(ID, CACHE[ID], 'ADMINS_LIST')

# =============================================================================== #
# === <<<> ADMINS SUB FUNCTIONS <>>> ============================================ #
# =============================================================================== #
def can(TARGET, KEY, MSG=True, R=False):
	ID = es.getplayersteamid(TARGET)
	if isAdmin(ID):
		if not db['admins'][ID]['Super Admin']:
			G = db['admins'][ID]['group']
			if not KEY == 'Ban':
				if not KEY in access: KEY = 'Fun Controls'
				if G: GKEY = db['groups'][G][KEY]
				else: GKEY = False
				if db['admins'][ID][KEY] or GKEY: R = True
			else:
				KEY = 'Ban Level'
				if G: GKEY = db['groups'][G][KEY]
				else: GKEY = 0
				R = max(db['admins'][ID][KEY],GKEY)
		else: R = True
	if not R and MSG: func.hudhint(TARGET, func.langAdmins('NO_ACCESS'), func.adminstag)
	return R

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def immunity(ADMIN, TARGET, MSG=True):
	ADMIN  = playerlib.getPlayer(ADMIN)
	TARGET = playerlib.getPlayer(TARGET)
	if isAdmin(TARGET) and ADMIN.userid != TARGET.userid:
		admins = db['admins']
		groups = db['groups']
		if not admins[TARGET.steamid]['Super Admin']:
			if admins[ADMIN.steamid]['Super Admin']: return True
			else:
				admin_group = admins[ADMIN.steamid]['group']
				admin_imm   = admins[ADMIN.steamid]['imm']
				if admin_group: admin_g_imm = groups[admin_group]['imm']
				else: admin_g_imm = 0
				target_group = admins[TARGET.steamid]['group']
				target_imm   = admins[TARGET.steamid]['imm']
				if target_group: target_g_imm = groups[target_group]['imm']
				else: target_g_imm = 0
				if max(admin_imm,admin_g_imm) > max(target_imm,target_g_imm): return True
				else:
					func.hudhint(ADMIN, func.langAdmins('IMMUNITY_FALSE'), func.adminstag)
					return False
		else:
			func.hudhint(ADMIN, func.langAdmins('TARGET_IS_SA'), func.adminstag)
			return False
	return True

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def isAdmin(ID, MSG=False):
	if es.getplayersteamid(es.getuserid(ID)) in db['admins']: return True
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def adminsList(): return list(db['admins'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def update(ADMIN):
	db['admins'][ADMIN.steamid]['name'] = ADMIN.name
	for x in access:
		if not x in db['admins'][ADMIN.steamid]: db['admins'][ADMIN.steamid][x] = False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def toggle(TARGET, DB):
	t = db[DB][TARGET]
	if CACHE['t']: t['Ban Level'] = 2
	else: t['Ban Level'] = 0
	for x in access: t[x] = CACHE['t']
	db[DB][TARGET].update(t)
	if CACHE['t']: CACHE['t'] = False
	else: CACHE['t'] = True

# =============================================================================== #
# === <<<> GROUPS SUB FUNCTIONS <>>> ============================================ #
# =============================================================================== #
def add_group(ID, GROUP):
	l = GROUP.lower()
	d = db['groups']
	if not GROUP in d:
		d[l] = {'name':GROUP,'imm':0,'Ban Level':0,'color':random.choice(list(func.colors))}
		for x in access: d[l][x] = False
		db.update(d)
		func.hudhint(ID, func.langAdmins('GROUP_ADDED', {'group':GROUP}), func.adminstag)
		edit_group(ID, l, 'ADMINS_MAIN')
	else:
		func.hudhint(ID, func.langAdmins('GROUP_EXISTS', {'group':GROUP}), func.adminstag)
		page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def remove_group(ID, GROUP, POPUP):
	del db['groups'][GROUP]
	for x in db['admins']:
		if db['admins'][x]['group'] == GROUP: db['admins'][x]['group'] = False
	func.hudhint(ID, func.langAdmins('GROUP_REMOVED',{'group':GROUP.capitalize()}), func.adminstag)
	page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def edit_group(ID, GROUP, POPUP=False, PAGE=False):
	if not POPUP: POPUP = 'GROUPS_LIST'
	CACHE[ID] = GROUP
	logic = {True:func.langCommon('YES'),False:func.langCommon('NO')}
	group = db['groups'][GROUP]
	popup = func.easymenu(('GROUPS_EDIT', edit_group_SELECT),'GROUPS_LIST',False)
	popup.c_beginsep = '%s\n%s: %s\n%s' % (func.line,func.langCommon('GROUP').upper(),group['name'],func.line)
	popup.settitle(func.header(func.langAdmins('EDIT_GROUP_OPTION')))
	popup.addoption(1, func.langAdmins('GROUPS_QUICK_ADD'))
	popup.addoption(2, func.langAdmins('TOGGLE_ACCESS'))
	popup.addoption(3, '%s: %s' % (func.langCommon('COLOR'),group['color'].replace('#','').capitalize()))
	popup.addoption(4, '%s: %s' % (func.langAdmins('IMMUNITY_LEVEL'),group['imm']))
	popup.addoption(5, 'Ban Level: %s' % group['Ban Level'])
	for x in access: popup.addoption(x, '%s: %s' % (x,logic[group[x]]))
	if not PAGE: popup.send(ID)
	else: popup.sendPage(ID, PAGE)

# ------------------------------------------------------------------------------- #
def edit_group_SELECT(ID, KEY, POPUP):
	GROUP = db['groups'][CACHE[ID]]
	if   KEY == 1:
		popup = func.easymenu(('GROUPS_QUICK_ADD', groups_quick_add_SELECT),'GROUPS_EDIT')
		popup.settitle(func.header(func.langAdmins('EDIT_GROUP_OPTION')))
		for x in adminsList():
			if db['admins'][x]['group'] == CACHE[ID]: popup.addoption(x, ' [X] %s' % db['admins'][x]['name'])
			else: popup.addoption(x, ' [  ] %s' % db['admins'][x]['name'])
		popup.send(ID)
	elif KEY == 2: toggle(CACHE[ID], 'groups')
	elif KEY == 3:
		popup = func.easymenu(('GROUPS_COLOR', group_color_SELECT),'GROUPS_EDIT')
		popup.settitle(func.header(func.langAdmins('EDIT_GROUP_OPTION')))
		for x in func.colors: popup.addoption(x, x.replace('#','').capitalize())
		popup.send(ID)
	elif KEY == 4:
		popup = func.easymenu(('GROUPS_IMMUNITY_EDIT', group_immunity_edit_SELECT),'GROUPS_EDIT')
		popup.settitle(func.header(func.langAdmins('EDIT_GROUP_OPTION')))
		num = 0
		while num <= 100:
			popup.addoption(num, num)
			num += 10
		popup.send(ID)
	elif KEY == 5:
		logic = {0:1,1:2,2:0}
		GROUP['Ban Level'] = logic[GROUP['Ban Level']]
	else:
		if GROUP[KEY]: GROUP[KEY] = False
		else: GROUP[KEY] = True
	db['groups'][CACHE[ID]].update(GROUP)
	if not KEY in (1,3,4):
		if KEY in access: PAGE = func.sendPage(access.index(KEY)+5)
		else: PAGE = 1
		edit_group(ID, CACHE[ID], None, PAGE)

# ------------------------------------------------------------------------------- #
def groups_quick_add_SELECT(ID, ADMIN, POPUP):
	if db['admins'][ADMIN]['group'] == CACHE[ID]: a = False
	else: a = CACHE[ID]
	db['admins'][ADMIN]['group'] = a
	edit_group_SELECT(ID, 1, None)

# ------------------------------------------------------------------------------- #
def group_color_SELECT(ID, COLOR, POPUP):
	db['groups'][CACHE[ID]]['color'] = COLOR
	edit_group(ID, CACHE[ID], None)

# ------------------------------------------------------------------------------- #
def group_immunity_edit_SELECT(ID, LEVEL, POPUP):
	db['groups'][CACHE[ID]]['imm'] = LEVEL
	func.hudhint(ID, func.langAdmins('GROUP_IMMUNITY_EDITED',{'group':db['groups'][CACHE[ID]]['name'],'imm':LEVEL}), func.adminstag)
	edit_group(ID, CACHE[ID], None)

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def resetCMD(ARGS):
	if ARGS:
		if str(ARGS[0]) == str(es.ServerVar('rcon_password')):
			db['admins'] = {}
			unload()
			load()
			func.log('Admins database has been reset.',func.adminstag)
		else: func.log('Incorrect RCON password.',func.errortag)
	else: func.log('Server RCON needed to use this command.',func.errortag)

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def create_admin(ID):
	popup = func.simplemenu('CREATE_ADMIN')
	popup.addline(func.header(func.langCommon('TITLE_ADMINS')))
	popup.addline(func.line)
	popup.addline(func.langAdmins('NOADMINS_LINE1'))
	popup.addline(func.langAdmins('NOADMINS_LINE2'))
	popup.addline(' \n%s' % func.langAdmins('NOADMINS_LINE3'))
	popup.addline('->1. %s' % func.langCommon('YES'))
	popup.addline('->2. %s' % func.langCommon('NO'))
	popup.addline(func.line)
	popup.addline('->0. %s' % func.langCommon('CANCEL'))
	popup.menuselect = create_admin_SELECT
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def create_admin_SELECT(ID, CHOICE, POPUP):
	if CHOICE == 1:
		CACHE[ID] = 'create'
		es.addons.registerSayFilter(create_admin_FILTER)
		func.tell(ID, '#spec'+func.langAdmins('CONFIRM_RCON'), func.adminstag)
	func.popupDelete('CREATE_ADMIN')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def create_admin_FILTER(ID, TEXT, TEAM):
	if ID in CACHE and CACHE[ID]:
		if str(TEXT.strip('"')) == str(es.ServerVar('rcon_password')):
			core.home(ID, False)
			page(ID, False)
			add(ID, playerlib.getPlayer(ID), 'ADMINS_MAIN', True, True)
			func.hudhint(ID, func.langAdmins('RCON_CONFIRMED'), func.adminstag)
		else: func.hudhint(ID, func.langAdmins('RCON_INCORRECT'), func.adminstag)
		es.addons.unregisterSayFilter(create_admin_FILTER)
		return (0, 0, 0)
	else: return (ID, TEXT, TEAM)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def create_group_FILTER(ID, TEXT, TEAM):
	if ID in CACHE and CACHE[ID] == 'GROUP_FILTER':
		TEXT = TEXT.strip('"')
		if TEXT == '!cancel':
			func.hudhint(ID, func.langCore('OP_CANCEL'), func.servertag)
			page(ID)
		else: add_group(ID, TEXT)
		func.cloud['filters'].remove(ID)
		es.addons.unregisterSayFilter(create_group_FILTER)
		return (0, 0, 0)
	else: return (ID, text, teamonly)

# =============================================================================== #